{{
  DPG - 3 Feb 09:  Need to fix Accelerometer Demo to ensure it is working.

}}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  ledind1 = 11
  ledind2 = 12
  ledind3 = 13
  ledind4 = 14
  drivepin = 0
  steerpin = 27
  xbeetx   = 4
  xbeerx   = 3
  gpsrx    = 2
  I2CSCL   = 5 
  I2CSDA   = 6
  I2CCS    = 7

  GPSport   = 1
  XBEEport  = 0


VAR
  long vref,x,y,z,ThetaA,ThetaB,ThetaC  
OBJ             
  STEER: "Servo32v3"
  UART: "pcFullDuplexSerial4FC"
  H48C :     "H48C Tri-Axis Accelerometer"
  FMATH : "FloatMath"
  FSTRING : "FloatString"



PUB main | i
  dira[ledind1]~~
  STEER.Set(steerpin,1500)
  STEER.Start
   repeat
    !outa[ledind1]
    repeat i from 1450 to 1750
     STEER.set(steerpin, i)
     waitcnt(1000_000 + cnt)
   
    repeat i from 1750 to 1450
      STEER.set(steerpin, i)
      waitcnt(1000_000 + cnt)
  teststeer

PUB testacc | xstr, xfl, ystr, yfl, zstr, zfl 
  
  UART.Init
  UART.AddPort(XBEEport,xbeerx,xbeetx,UART#PINNOTUSED,UART#PINNOTUSED,UART#DEFAULTTHRESHOLD,0,115200)
  UART.Start
  UART.rxflush(XBEEport)
  H48C.start(I2CCS,I2CSDA,I2CSCL)


  repeat 
    !outa[ledind1]
     'vref := (H48C.vref*825)/1024   '<-- Here's how to get vref in mV

     vref := H48C.vref               '<-- Here's how to get vref in RAW
          

'Note: The returned value for X, Y, and Z is equal to the axis - Vref
        x := H48C.x  '<-- Here's how to get x 
        y := H48C.y  '<-- Here's how to get y
        z := H48C.z  '<-- Here's how to get z

'Note: The returned value is in Deg (0-359)
'      remove the '*45)/1024' to return the 13-Bit Angle
   ThetaA := (H48C.ThetaA*45)/1024   '<-- ThetaA is the angle relationship between X and Y
   ThetaB := (H48C.ThetaB*45)/1024   '<-- ThetaB is the angle relationship between X and Z
   ThetaC := (H48C.ThetaC*45)/1024   '<-- ThetaC is the angle relationship between Y and Z
   xfl := FMATH.FFloat(x)
   'xfl := FMATH.Fdiv(480,xfl)
   'xfl := FMATH.Fround(xfl)
   zfl := FMATH.FFloat(z)
   'zfl := FMATH.Fdiv(480,zfl)
   'zfl := FMATH.Fround(zfl)
   xstr := FSTRING.FloatToScientific(xfl)
   zstr := FSTRING.FloatToString(zfl)
    UART.str(0,string("x = "))
    UART.dec(0,x)
    UART.str(0,string(",")) 
    UART.str(0,xstr)
    UART.tx(0,13)
    UART.str(0,string("z = "))
    UART.dec(0,z)
    UART.str(0,string(","))  
    UART.str(0,zstr)
    UART.tx(0,13)
    

    
    waitcnt(10000_000 + cnt)
   
{PUB testi2c | buff
  dira[ledind1]~~
  UART.Init
  UART.AddPort(XBEEport,xbeerx,xbeetx,UART#PINNOTUSED,UART#PINNOTUSED,UART#DEFAULTTHRESHOLD,0,115200)
  UART.rxflush(XBEEport)

  I2C.Initialize(I2CSCL)


  repeat 

        if I2C.devicePresent(I2CSCL,AccelerometerAddress) == true
            UART.strln(XBEEport,string("Accelerometer Present"))
            'AccDemo
        else
            UART.str(XBEEport,string("Accelerometer Missing"))      
        waitcnt(clkfreq*3+cnt)

}
{PRI AccDemo | tempvar,ackbit
    ' DEMO Accelerometer
    debug.strln(XBEEport,String("Accelerometer Demo..."))

    ' setup the config - one shot conversion mode
    DS1621Object.writeConfig(i2cSCL,ds1621addr,ds1621object#_OneShotMode)

    ' wait tick or two
    waitcnt(clkfreq*2+cnt)

    repeat 5
        ' init temp conversion
        DS1621Object.startConversion(i2cSCL,ds1621addr)
         
        ' wait a tick or two
        waitcnt(clkfreq+cnt)
         
        ' read temp C
        tempvar := DS1621Object.readTempC(i2cSCL,ds1621addr)

        debug.str(string("Temp is "))
        debug.dec (tempvar)
         
        ' read the Config register - it displays 65 - i.e. %0100_0001 - TH and data ready set
        tempvar := DS1621Object.readConfig(i2cSCL,ds1621addr)
        debug.str(string(",  ConfigReg  is  %"))
        debug.bin (tempvar,8)
        debug.putc(13)
         
        ' wait several ticks
        waitcnt(clkfreq*2+cnt)
} 

PUB testgpsuart | buff

  dira[ledind1]~~
  UART.Init
  UART.AddPort(XBEEport,xbeerx,xbeetx,UART#PINNOTUSED,UART#PINNOTUSED,UART#DEFAULTTHRESHOLD,0,115200)
  'GPS.Init   
  UART.AddPort(GPSport,gpsrx,UART#PINNOTUSED,UART#PINNOTUSED,UART#PINNOTUSED,UART#DEFAULTTHRESHOLD,0,4800)
  UART.Start

  UART.rxflush(XBEEport)
  UART.rxflush(GPSport) 
  repeat
    !outa[ledind1..ledind1+3]
    buff := UART.rx(GPSport)
    waitcnt( 100_000 + cnt)
    UART.tx(XBEEport,buff)
    
       

PUB teststeer | i         
  
  repeat
    !outa[ledind1]
    repeat i from 1450 to 1750
     STEER.set(steerpin, i)
     waitcnt(1000_000 + cnt)
   
    repeat i from 1750 to 1450
      STEER.set(steerpin, i)
      waitcnt(1000_000 + cnt)
PUB teststeer2 
    
       